
; source-code := string

#|
(defun source-is-ground (source)
  (or (integerp source)
      (and (consp source)
	   (list.forall #'source-is-ground (cdr source)))))
|#

; ACL2-expression -> source-code
(defun create-source-code-ACL2 (exp name-map)
  (if (consp exp)
      (let* ((op (car exp))
	     (args (cdr exp)))
	(if (or (equal op 'c-uint-/) (equal op 'c-int-/) (equal op 'c-mod))
	    (let* ((lhs (create-source-code-ACL2 (car args) name-map))
		   (rhs (create-source-code-ACL2 (cadr args) name-map))
		   (op-source (cond ((equal op 'c-uint-/) "/")
				 ((equal op 'c-int-/) "/")
				 ((equal op 'c-mod) "%"))))
	      (if (and (integerp rhs) (not (equal rhs 0)))
		  (string-append-all (list lhs " " op-source " " rhs))
	      (string-append-all (list "((" rhs " == 0) ? 0 : " lhs " " op-source " " rhs ")"))))
	  (let* ((op-source (cond ((equal op 'c-uint-+) "+")
				  ((equal op 'c-int-+) "+")
				  ((equal op 'c-uint-*) "*")
				  ((equal op 'c-int-*) "*")
				  ;((equal op 'c-uint-/) "/")
				  ;((equal op 'c-int-/) "/")
				  ;((equal op 'c-mod) "%")
				  ((equal op 'c-uint-bin-and) "&")
				  ((equal op 'c-uint-bin-or) "|")
				  ((equal op 'c-uint-bin-xor) "^")
				  (t (progn (print (list 'unimplemented 'op op))
					    (error 'unimplemented))))))
	    (string-append-all (list "(" (create-source-code-ACL2 (car args) name-map)
				     " " op-source " "
				     (create-source-code-ACL2 (cadr args) name-map) ")")))))
    (if (integerp exp)
	(write-to-string exp)
      (if (booleanp exp)
	  (if exp "true" "false")
	(let* ((mapped (map.find-exn name-map exp)))
	  (if (symbolp mapped) (symbol-name mapped) mapped))))))

(defun create-source-code-from-single (invariant name-map)
  (cond ((equal (car invariant) 'or)
	 (string-append-all (list "(" (create-source-code-from-single (cadr invariant) name-map)
				  "||"
				  (create-source-code-from-single (caddr invariant) name-map)
				  ")")))
	((equal (car invariant) 'not)
	 (string-append-all (list "!" (create-source-code-from-single (cadr invariant) name-map))))
	(t (string-append-all (list "("
				    (create-source-code-ACL2 (cadr invariant) name-map)
				    (cond ((equal (car invariant) 'equal)
					   " == ")
					  ((equal (car invariant) '<)
					   " < ")
					  ((equal (car invariant) '<=)
					   " <= ")
					  (t (error 'unimplemented)))
				    (create-source-code-ACL2 (caddr invariant) name-map)
				    ")")))))

; [ACL2-expression list] [ACL2-var (list ACL2-var var) map] -> source-code
(defun create-source-code-from-invariants (invariants name-map)
  (if (endp invariants)
      (error 'unimplemented)
    (list.foldr #'(lambda (inv acc)
		    (string-append-all (list (create-source-code-from-single inv name-map) " && " acc)))
		(create-source-code-from-single (car invariants) name-map)
		(cdr invariants))))

(defun find-source-code (input-file-string loc)
  (let* ((offset (l.find loc ':offset))
	 (length (l.find loc ':length)))
    (subseq input-file-string offset (+ offset length))))

(define-condition no-source-code (error)
  ((text :initarg :text :reader text)))

#|
; statement -> source-code
(defun statement-to-source-code (stm)
  (l.find stm ':source-code))

; statement -> source-code
(defun expression-to-source-code (exp)
  (l.find exp ':source-code))

(defun type-to-source-code (type)
  (cond ((equal type 'uint) "unsigned int")
	((equal type 'int) "int")
	((equal type 'bool) "bool")
	((equal type 'char) "char")))

(defun c-declaration-to-source-code (declaration)
  (cond ((equal (car declaration) 'simple-declaration)
	 (if (equal (length (l.find declaration ':declarators)) 1)
	     (let* ((declarator (car (l.find declaration ':declarators)))
		    (decl-spec (l.find declaration ':decl-specifier)))
	       (cond ((equal (car declarator) 'declarator)
		      (let* ((name (let* ((name-opt (l.find declarator ':name)))
				     (cond ((equal (car name-opt) 'name)
					    (cadr name-opt))
					   ((equal (car name-opt) 'unnamed)
					    (error 'no-source-code)))))
			     (initializer (l.find declarator ':initializer))
			     (type (convert-decl-type (l.find decl-spec ':decl-type)))
			     (init-string (if (equal initializer '_)
					      ";"
					   (string-append-all (list " = "
								    (c-expression-to-source-code (l.find (l.find initializer ':initializer-clause) ':expression))
								    ";")))))
			(string-append-all (list (type-to-source-code (l.find type ':kind))
						 " "
						 (string-downcase (string name))
						 init-string))))
		     ((equal (car declarator) 'function-declarator)
		      (error 'no-source-code))))
	   (error 'no-source-code)))
	((equal (car declaration) 'function-declaration)
	 (error 'no-source-code))))

(defun binary-op-to-source-code (op)
  (cond ((equal op 'assign) "=")
	((equal op 'bin-and) "&")
	((equal op 'assign-bin-and) "&=")
	((equal op 'bin-or) "|")
	((equal op 'assign-bin-or) "|=")
	((equal op 'bin-xor) "^")
	((equal op 'assign-bin-xor) "^=")
	((equal op '==) "==")
	((equal op '!=) "!=")
	((equal op '>=) ">=")
	((equal op '>) ">")
	((equal op '<=) "<=")
	((equal op '<) "<")
	((equal op 'log-and) "&&")
	((equal op 'log-or) "||")
	((equal op '+) "+")
	((equal op 'assign-+) "+=")
	((equal op '-) "-")
	((equal op 'assign-) "-=")
	((equal op '*) "*")
	((equal op 'assign-*) "*=")
	((equal op '/) "/")
	((equal op 'assign-/) "/=")
	((equal op 'mod) "%")
	((equal op 'assign-mod) "%=")
	((equal op '<<) "<<")
	((equal op '<<=) "<<=")
	((equal op '>>) ">>")
	((equal op '>>=) ">>=")))

; c-unary-op string -> string
(defun unary-op-to-source-code (op exp-string)
  (cond ((equal op 'reference)  (string-append "&" exp-string))
	((equal op 'dereference) (string-append "*" exp-string))
	((equal op '-) (string-append "-" exp-string))
	((equal op '+) (string-append "+" exp-string))
	((equal op 'log-not) (string-append "!" exp-string))
	((equal op 'bin-not) (string-append "~" exp-string))
	((equal op 'decr-post) (string-append exp-string "--"))
	((equal op 'incr-post) (string-append exp-string "++"))
	((equal op 'decr-pre) (string-append "--" exp-string))
	((equal op 'incr-pre) (string-append "++" exp-string))
	((equal op 'parens) (string-append "(" (string-append exp-string ")")))))

; c-expression -> source-code
(defun c-expression-to-source-code (exp)
  (cond ((equal (car exp) 'literal-expression)
	 (let* ((value (l.find exp ':value)))
	   (cond ((integerp value) (write-to-string value))
		 ((boolp value) (if value "true" "false"))
		 (t "???"))))
	((equal (car exp) 'id-expression)
	 (let* ((name (l.find exp ':name)))
	   (if (equal (car name) 'name)
	       (string-downcase (string (cadr name)))
	     (error 'no-source-code))))
	((equal (car exp) 'unary-expression)
	 (let* ((operator (l.find exp ':operator))
		(operand (l.find exp ':operand))
		(res (c-expression-to-source-code operand)))
	   (unary-op-to-source-code operator res)))
		
	((equal (car exp) 'binary-expression)
	 (let* ((operator (l.find exp ':operator))
		(operand1 (l.find exp ':operand1))
		(operand2 (l.find exp ':operand2))
		(res1 (c-expression-to-source-code operand1))
		(res2 (c-expression-to-source-code operand2)))
	   (string-append-all (list "(" res1 " " (binary-op-to-source-code operator) " " res2 ")"))))
	((equal (car exp) 'function-call-expression)
	 (let* ((func (l.find exp ':function)))
	   (cond ((and (equal (car func) 'id-expression)
		       (equal (car (l.find func ':name)) 'name))
		  (let* ((name (cadr (l.find func ':name)))
			 (loc (l.find exp ':loc)))
		    (cond ((equal name '__VERIFIER_nondet_uint)
			   "__VERIFIER_nondet_uint()")
			  ((equal name '__VERIFIER_nondet_int)
			   "__VERIFIER_nondet_int()")
			  ((equal name '__VERIFIER_nondet_bool)
			   "__VERIFIER_nondet_bool()")
			  ((equal name '__VERIFIER_nondet_char)
			   "__VERIFIER_nondet_char()")

			  ((equal name '__VERIFIER_assert)
			   (let* ((assert-res (c-expression-to-source-code (l.find (car (l.find exp ':arguments)) ':expression))))
			     (string-append-all (list "__VERIFIER_assert(" assert-res ")"))))

			  (t (error 'no-source-code)))))
		  (t (error 'no-source-code)))))
	((equal (car exp) 'compound-statement-expression)
	 (error 'no-source-code))
	((equal (car exp) 'conditional-expression)
	 (let* ((test-res (c-expression-to-source-code (l.find exp ':test)))
		(then-res (c-expression-to-source-code (l.find exp ':then)))
		(else-res (c-expression-to-source-code (l.find exp ':else))))
	   (strng-append-all (list test-res " ? " then-res " : " else-res))))
	(t (error 'no-source-code))))
	
; c-statement -> source-code
(defun c-statement-to-source-code (stm)
  (cond ((equal (car stm) 'compound-statement)
	 (list.foldr #'(lambda (stm* acc)
			 (string-append (c-statement-to-source-code stm*) acc))
		     "" (l.find stm ':statements)))

	((equal (car stm) 'return-statement)
	 (if (equal (l.find stm ':expression) '_)
	     "return;"
	   (string-append-all (list "return " (c-expression-to-source-code (l.find stm ':expression)) ";"))))
	((equal (car stm) 'if-statement)
	 (let* ((test-res (c-expression-to-source-code (l.find stm ':test)))
		(then-res (c-statement-to-source-code (l.find stm ':then))))
	   (if (equal (l.find stm ':else) '_)
	       (string-append-all (list "if " test-res "{" then-res "}"))
	     (let* ((else-res (c-statement-to-source-code (l.find stm ':else))))
	       (string-append-all (list "if " test-res "{" then-res "} else {" else-res "}"))))))

	((equal (car stm) 'while-statement)
	 (let* ((test-res (c-expression-to-source-code (l.find stm ':test)))
		(body-res (c-statement-to-source-code (l.find stm ':body))))
	 (string-append-all (list "while " test-res "{" body-res "}"))))

	((equal (car stm) 'do-statement)
	 (let* ((test-res (c-expression-to-source-code (l.find stm ':test)))
		(body-res (c-statement-to-source-code (l.find stm ':body))))
	   (string-append-all (list "do " "{" body-res "}" " while " test-res))))

	((equal (car stm) 'for-statement)
	 (let* ((init-res (c-statement-to-source-code (l.find stm ':init)))
		(test-res (c-expression-to-source-code (l.find stm ':test)))
		(iter-res (c-expression-to-source-code (l.find stm ':iter)))
		(body-res (c-statement-to-source-code (l.find stm ':body))))
	   (string-append-all (list "for (" init-res test-res "; " iter-res ") {" body-res "}"))))

	((equal (car stm) 'break-statement)
	 "break;")
	((equal (car stm) 'continue-statement)
	 "continue;")
	((equal (car stm) 'default-statement)
	 "default;")
	((equal (car stm) 'null-statement)
	 "null;")
	((equal (car stm) 'goto-statement)
	 (error 'no-source-code))
	((equal (car stm) 'declaration-statement)
	 (c-declaration-to-source-code (l.find stm ':declaration)))
	((equal (car stm) 'expression-statement)
	 (string-append (c-expression-to-source-code (l.find stm ':expression)) ";"))
	((equal (car stm) 'case-statement)
	 (error 'no-source-code))
	((equal (car stm) 'switch-statement)
	 (error 'no-source-code))
	((equal (car stm) 'label-statement)
	 (error 'no-source-code))))
|#
